// map.h

class CMap
{
public:
	CMap(void);
	~CMap(void);

	void Loop(void);
	bool Init(void);
	void Exit(void);
	void Reset(void);

	void SetAllTokensToStartFields(void);
	void EnableActivePlayerSign(irr::s32 iPlayer);
	void DisableActivePlayerSign(irr::s32 iPlayer);

	bool IsATokenOnTheMove();

	bool CheckIfPlayerGotItemAtRel0(irr::s32 iPlayer, irr::s32& iRetValue);
	bool CheckIfPlayerGotOutOfGameItems(irr::s32 iPlayer, irr::s32& iRetValue);
	bool CheckIfPlayerGotIngameItems(irr::s32 iPlayer, irr::s32& iRetValue);
	bool CheckIfPlayerItemCanWalk(irr::s32 iPlayer, irr::s32 iItem, irr::s32 iDiceRoll);
	bool CheckIfPlayerCanSlayAnother(irr::s32 iPlayer, irr::s32 iDiceRoll, irr::s32& iRetItem);
	bool CheckIfPlayerCanBringItemHome(irr::s32 iPlayer, irr::s32 iDiceRoll, irr::s32& iRetItem);
	bool CheckIfaPlayerItemCanWalk(irr::s32 iPlayer, irr::s32 iDiceRoll, irr::s32& iRetItem);
	bool CheckIfPlayerHasWon(irr::s32 iPlayer);

	void MovePlayerItem(irr::s32 iPlayer, irr::s32 iItem, irr::s32 iDiceRoll);
	void DeleteMoveJobs(void);

	ONETOKEN m_Tokens[4][4];        // [players] [items]
	irr::scene::ISceneNode* m_pPlaneNode;
	
private:
	bool InitSkyBox(void);
	bool InitGamePlane(void);
	bool InitMainWalkingFields(void);
	bool InitStartFields(void);
	bool InitHomeFields(void);
	bool InitInitFields(void);

	bool InitPlayerTokens(void);

	irr::s32 GetAbsoluteFromRelativeIndex(irr::s32 iPlayer, irr::s32 iRelIndex);
	irr::s32 GetRelativeFromAbsoluteIndex(irr::s32 iPlayer, irr::s32 iAbsIndex);
	bool CheckIfItemIsAtAbsoluteIndex(irr::s32 iCallingPlayer, irr::s32 iAbsIndex, irr::s32& iPlayer, irr::s32& iRetItem);
	void CheckForSlayingItem(irr::s32 iAbsIndex);
	void InitMoveJob(irr::s32 iPlayer, irr::s32 iItem, irr::s32 newRelIndex);
	void ProcessMoveJobs(void);	

	ONEFIELD m_MainFields[40];		// index 0 is init field of player 1
	ONEFIELD m_StartFields[4][4];	// [players] [items]
	ONEFIELD m_EndFields[4][4];		// [players] [items]	

	irr::core::array<MOVEJOB> m_aMoveJobs;
};

